﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace CarFire
{
    public class Display
    {
        List<Projectile> mProjectiles = new List<Projectile>();
        List<Character> mCharacters = new List<Character>();
        Map mMap;
        public Display()
        {
            /*
            mMap = aMap;
            mCharacters = characters;
             */
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        public void LoadContent(ContentManager contentManager)
        {
            Texture2D everything = contentManager.Load<Texture2D>("cs");
            mMap = contentManager.Load<Map>("Maps/stable");
            Map.DefaultTile = contentManager.Load<Texture2D>("default");
            mMap.CenterCell = new Vector2(5,5);
            //List<object> entities = mMap.GetAllEntities();
            mProjectiles.Add(new Projectile(mMap, everything, new Vector2(5,5), 10, 10, 300, 300));
            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        public void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public void Update(TimeSpan timespan)
        {
           
            foreach (Projectile projectile in mProjectiles)
            {
                projectile.Update(timespan);
            }
            //Check for collisons
            foreach (Character character in mCharacters)
            {
                foreach (Projectile projectile in mProjectiles)
                {
                    if (projectile.GridX == character.GridX && projectile.GridY == character.GridY)
                    {
                        //Debug - not sure if you can remove while doing for each
                        //Alternative - while loop, and decrement projectile counter if projectile is removed.
                        mProjectiles.Remove(projectile);
                        character.Health -= projectile.Damage;
                    }
                }
            }
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public void Draw(SpriteBatch spriteBatch)
        {
            mMap.Draw(spriteBatch);
            foreach(Projectile projectile in mProjectiles)
            {
                projectile.Draw(spriteBatch);
                
            }
            foreach(Character character in mCharacters)
            {
                character.Draw(spriteBatch);
            }

            
        }
    }
}

